<?php
namespace Teknisa\FIS\Modules\Acessorias\Services;

use Teknisa\FIS\Modules\Acessorias\Services\Jobs;

class Agendamento
{

	public static function criaJob($nomeJob, $dataContabAuto, $sequencialJob, $nrorg, $descricao, $arqCallService, $dirphp, $jenkinsPath, $execPath, $periodicidade, $jenkinsCreateItem = null)
    {
        try {

			$requestUri = $_SERVER["REQUEST_URI"];

            if(strpos($requestUri, "modules") == false) {
                $urlServer = 'http://'.$_SERVER["HTTP_HOST"].'//backend_fis/index.php'.$execPath;

            }
            else {
                if(strpos($_SERVER["DOCUMENT_ROOT"], "workfolder") != false) {
                    $threshold = strpos($requestUri, "index.php");
                    $resUri = substr($_SERVER["REQUEST_URI"], 0, $threshold);
                    $urlServer = 'https://'.$_SERVER["HTTP_HOST"].'/workfolder'.$resUri.'index.php'.$execPath;
                }
                else {
                    $threshold = strpos($requestUri, "index.php");
                    $resUri = substr($_SERVER["REQUEST_URI"], 0, $threshold);
                    $urlServer = 'https://'.$_SERVER["HTTP_HOST"].$resUri.'index.php'.$execPath;
                }
            }
            if((isset($arqCallService)) && ($arqCallService != null)){
    			$metodo = Jobs::revertDirectory(
                    $dirphp.'/php.exe "'.$arqCallService.'" url="'.$urlServer.'?NRAGENDAMENTO='.$sequencialJob.'&NRORG='.$nrorg.'"'
                );

                $jenkins = new Jobs($nomeJob, $jenkinsCreateItem, $jenkinsPath);

                $jenkins->setType(Jobs::TYPE_JOB_MULT_CONF);
                $jenkins->setUrlConfig(null);
                $jenkins->setPeriod($jenkins->formatDateToExecute($dataContabAuto, $periodicidade));
                $jenkins->setDescription($descricao);
                $jenkins->setMethod($metodo);
                $jenkins->createJob($jenkinsPath);
                $jenkins->configuration($jenkinsPath);

            } else {
                $metodo = 'curl "'.$urlServer.'?NRAGENDAMENTO='.$sequencialJob.'&NRORG='.$nrorg.'"';
                ///curl "https://tainafernandes.zeedhi.com/workfolder/erp/modules/fis/backend/service/index.php/execAgendamento?NRAGENDAMENTO=0000000082&NRORG=1"

                $jenkins = new Jobs($nomeJob, $jenkinsCreateItem, $jenkinsPath);

                $jenkins->setType(Jobs::TYPE_JOB_MULT_CONF);
                $jenkins->setUrlConfig(null);
                $jenkins->setperiod($jenkins->formatdatetoexecute($dataContabAuto, $periodicidade));
                $jenkins->setDescription($descricao);
                $jenkins->setMethod($metodo);
                $jenkins->createJobLinux($jenkinsPath);
                $jenkins->configurationLinux($jenkinsPath);

            }
            //C:\xampp\php\php.exe "C:\Teknisa\CallService.php" url="https://tainafernandes.zeedhi.com/workfolder/erp/modules/fis/backend/service/index.php/execAgendamento" NRAGENDAMENTO="0000000047" NRORG="2025"

        } catch (\Exception $e) {
            throw new \Exception("Houve um erro ao comunicar com o Jenkins: ".$e->getMessage());
        }
    }

	public static function apagaJob($nomeJob, $createItem, $jenkinsPath, $arqCallService = null)
	{
	    try {
    		$jenkins = new Jobs($nomeJob, $createItem, $jenkinsPath);
    		$jenkins->setUrlDelete($nomeJob);
    		if((isset($arqCallService)) && ($arqCallService != null)){
        		$jenkins->deleteJob();
    		} else {
        		$jenkins->deleteJobLinux($jenkinsPath);
    		}
	    } catch (\Exception $e) {
            throw new \Exception("Houve um erro ao comunicar com o Jenkins: ".$e->getMessage());
        }
	}

}
