<?php

namespace Teknisa\FIS\Factories;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Geral\Entities\Paramgeral;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Teknisa\Model\Geral\Entities\Contctbl;

class Fis02600ClassificacaoFiscalFactory {
  
    protected $connection;
    protected $newCode;
    protected $entityManager;

    public function __construct(EntityManager $entityManager, NewCode $newCode) {
      $this->connection = $entityManager->getConnection();
      $this->entityManager = $entityManager;
      $this->newCode = $newCode;
    }
    
    public function insereNCM($dado) {
      $sql = "INSERT INTO CLASFISCAL
            (
                CDCLASFISC, 
        DSCLASFISC
            ) VALUES (
              :CDCLASFISC, 
        :DSCLASFISC
            )";
        
        $std = $this->connection->prepare($sql);
        $std->execute($dado);
    }
}